Unit AlgAppr;
{ Evaluation approche des formules de CalcAlg }
{ K.B. 1997 }

INTERFACE

Uses UPCalc, AlgConst, AlgUtil, AlgNode;

Function EvalFuncx(Name:TName; x:Real; Var Rep:Real):Boolean;
Function EvalFuncxy(Name:TName; x,y:Real; Var rep:Real):Boolean;
Function EvalNode(node:PNode; Var rep:Real):Boolean;

IMPLEMENTATION

Function EvalNode(node:PNode; Var rep:Real):Boolean;
Var ok: Boolean;
    r1,r2: Real;
    err: Integer;
Begin
 rep:=0.0;
 case node^.kind of
 _NUM :
  begin
   rep:=node^.value;
   EvalNode:=true;
   exit;
  end;
 _VAR :
  begin
   if node^.name='pi' then
    rep:=pi
   else if node^.name=ename then
    rep:=exp(1);
   if rep=0.0 then
    EvalNode:=false
   else EvalNode:=true;
   exit;
  end;
 _DEC :
  begin
   val(node^.name,rep,err);
   if err=0 then
    EvalNode:=true
   else EvalNode:=false;
  end;
 _FUN :
  begin
   case node^.nump of
    1 : begin
         ok:=EvalNode(node^.parm[0],r1);
         ok:=ok and EvalFuncX(node^.name,r1,rep);
        end;
    2 : begin
         ok:=EvalNode(node^.parm[0],r1);
         ok:=ok and EvalNode(node^.parm[1],r2);
         ok:=ok and EvalFuncXY(node^.name,r1,r2,rep);
        end;
    else ok:=false;
    end;
   EvalNode:=ok;
   exit;
  end;
 else begin
       if node^.nump=2 then
        begin
         ok:=EvalNode(node^.parm[0],r1);
         ok:=ok and EvalNode(node^.parm[1],r2);
         if ok then
          case node^.kind of
           _ADD : rep:=PAdd(r1,r2);
           _SUB : rep:=PSub(r1,r2);
           _MUL : rep:=PMul(r1,r2);
           _DIV : rep:=PDiv(r1,r2);
           _EXP : rep:=PPuiss(r1,r2);
           else ok:=false;
           end;
         if IsPCalcError or (not ok) then
          EvalNode:=false
         else EvalNode:=true;
        end
       else
        begin
         rep:=0.0;
         EvalNode:=false;
        end;
       exit;
      end;
 end;
End;

Function EvalFuncx(Name:TName; x:Real; Var rep:Real):Boolean;
Var ok:Boolean;
Begin
 ok:=true;
 if name='rac' then
  rep:=PSQRT(x)
 else if name='sin' then
  rep:=PSin(x)
 else if name='cos' then
  rep:=PCos(x)
 else if name='tan' then
  rep:=PTan(x)
 else if name='acos' then
  rep:=PArcCos(x)
 else if name='asin' then
  rep:=PArcSin(x)
 else if name='atan' then
  rep:=PArcTan(x)
 else if name='cosh' then
  rep:=PCh(x)
 else if name='sinh' then
  rep:=PSh(x)
 else if name='tanh' then
  rep:=PTh(x)
 else if name='ln' then
  rep:=PLn(x)
 else if name='log' then
  rep:=PLog(x)
 else if name='abs' then
  rep:=PAbs(x)
 else if name='rand' then
  rep:=PRandom(x)
 else if name='sign' then
  rep:=PSign(x)
 else ok:=false;
 EvalFuncx:=ok and (not IsPCalcError);
End;

Function EvalFuncxy(Name:TName; x,y:Real; Var rep:Real):Boolean;
Var ok:Boolean;
Begin
 ok:=true;
 if name='max' then
  rep:=PMax(x,y)
 else if name='min' then
  rep:=PMin(x,y)
 else if name='atan2' then
  rep:=PArcTan2(x,y)
 else if name='mod' then
  rep:=PMod(x,y)
 else if name='r' then
  rep:=PHypot(x,y)
 else ok:=false;
 EvalFuncxy:=ok and not(IsPCalcError);
End;


END.

{                         Fin du fichier ALGEVAL.PAS                        }
