Unit AlgCalc;
{ Calcul d'un noeud }
{ K.B. dc 97 }

INTERFACE

Uses UPCalc, AlgArit, AlgConst, AlgUtil, AlgNode, AlgSort, AlgAppr;

Function Calcnode(p:PNode):Integer;
{ calcul d'un noeud; renvoie un entier non nul si une transformation
  a t effectue }

Function FactoCarre(p:PNode):Integer;
{ Mise en facteur du plus grand facteur carr }

Procedure Primefact(p:PNode);
{ dcomposition en produit de facteurs premiers }

Function MoveNums(p:PNode; up,oper:Integer):Integer;
{ dplacement des nombres et calcul si possible
  up=1 pour dplacement vers la gauche
  oper est l'opration associative traite : addition ou multiplication }

Function CalcFunc(p:PNode):Integer;
{ calcul de fonctions; gre racine carre, valeur absolue, PGCD et PPCM }

IMPLEMENTATION

Const
 zero=1E-10;

(* IsComplex
   Reconnaissance d'un noeud reprsentant un nombre complexe
   Renvoie un entier suprieur  0 si c'est le cas et 1 pour
   un nombre entier.
   Place dans a la partie imaginaire et dans b la partie relle *)
Function IsComplex(p:PNode; var a,b:TDouble):Integer;
Begin
 if aop(p^.kind) and (p^.parm[1]^.kind=_NUM) and (p^.parm[0]^.kind=_MUL)
   and (p^.parm[0]^.parm[1]^.kind=_VAR) and (p^.parm[0]^.parm[0]^.kind=_NUM)
   and (p^.parm[0]^.parm[1]^.name='i') then
  begin  (* ai+b *)
   a:=p^.parm[0]^.parm[0]^.value;
   b:=p^.parm[1]^.value;
   if p^.kind=_SUB then b:=-b;
   iscomplex:=5;
   exit;
  end;
 if (p^.kind=_MUL) and (p^.parm[1]^.kind=_VAR) and (p^.parm[0]^.kind=_NUM)
   and (p^.parm[1]^.name='i') then
  begin  (* ai *)
   a:=p^.parm[0]^.value;  b:=0;
   iscomplex:=3;
   exit;
  end;
 if aop(p^.kind) and (p^.parm[1]^.kind=_NUM) and (p^.parm[0]^.kind=_MUL)
   and (p^.parm[0]^.parm[0]^.kind=_VAR) and (p^.parm[0]^.parm[1]^.kind=_NUM)
   and (p^.parm[0]^.parm[0]^.name='i') then
  begin  (* ia+b *)
   a:=p^.parm[0]^.parm[1]^.value;  b:=p^.parm[1]^.value;
   if p^.kind=_SUB then b:=-b;
   iscomplex:=5;
   exit;
  end;
 if (p^.kind=_MUL) and (p^.parm[0]^.kind=_VAR) and (p^.parm[1]^.kind=_NUM)
   and (p^.parm[0]^.name='i') then
  begin  (* ia *)
   a:=p^.parm[1]^.value; b:=0;
   iscomplex:=3;
   exit;
  end;
 if aop(p^.kind) and (p^.parm[0]^.kind=_VAR) and (p^.parm[1]^.kind=_NUM)
   and (p^.parm[0]^.name='i') then
  begin  (* i+b *)
   a:=1;   b:=p^.parm[1]^.value;
   if p^.kind=_SUB then b:=-b;
   iscomplex:=4;
   exit;
  end;
 if aop(p^.kind) and (p^.parm[1]^.kind=_VAR) and (p^.parm[0]^.kind=_NUM)
   and (p^.parm[1]^.name='i') then
  begin  (* b+i *)
   a:=1;   b:=p^.parm[0]^.value;
   if p^.kind=_SUB then a:=-a;
   iscomplex:=4;
   exit;
  end;
 if (p^.kind=_VAR) and (p^.name='i') then
  begin  (* i *)
   a:=1;  b:=0;
   iscomplex:= 2;
   exit;
  end;
 if p^.kind=_NUM then
  begin  (* b *)
   a:=0;   b:=p^.value;
   iscomplex:=1;
   exit;
  end;
 iscomplex:=0;
End;

Function Badnode:PNode;
Var p:PNode;
Begin
 p:=newnode;
 p^.kind:=_BAD;
 Badnode:=p;
End;

Function AlgRad(p:PNode):Integer;
Var tmp:PNode;
    n,d:TDouble;
Begin
 if p^.parm[0]^.kind=_NUM then
  begin
   n:=p^.parm[0]^.value; d:=180;
   SimpliFrac(n,d);
   tmp:=cons(newnum(n),_MUL,newvar('pi'));
   MoveNode(p,cons(tmp,_DIV,newnum(d)));
  end
 else
  begin
   tmp:=cons(deepcopy(p^.parm[0]),_MUL,newvar('pi'));
   MoveNode(p,cons(tmp,_DIV,newnum(180)));
  end;
 AlgRad:=1;
End;

Const
 mSin=0;
 mCos=1;
 mTan=2;

Procedure Modulo2Pi(var r:Real);
Var rep,q : Real;
Begin
 rep:=abs(r);
 q:=rep/(2*pi);
 rep:=rep-int(q)*2*pi;
 if r>0 then
  r:=rep
 else r:=2*pi-rep;
End;

Function AlgSinCos(p:PNode; m:Integer):Integer;
Var r:Integer;
    rep:Real;
Begin
 r:=0;
 if EvalNode(p^.parm[0],rep) then
  begin
   if m=mSin then
    begin
     m:=mCos; rep:=pi/2-rep;
    end;
   Modulo2Pi(rep);
   if rep>pi then
    if m=mCos then
     rep:=2*pi-rep
    else rep:=rep-pi;
   if (abs(rep)<zero) or (abs(rep-pi)<zero) then
    begin
     if m=mCos then
      begin
       if abs(rep)<zero then
        MoveNode(p,newnum(1))
       else MoveNode(p,newnum(-1));
      end
     else MoveNode(p,newnum(0));
     inc(r);
    end
   else if abs(rep-pi/2)<zero then
    begin
     if m=mCos then
      MoveNode(p,newnum(0))
     else MoveNode(p,Badnode);
     inc(r);
    end
   else if abs(rep-pi/4)<zero then
    begin
     if m=mTan then
      MoveNode(p,newnum(1))
     else MoveNode(p,cons(consfunc('rac',newnum(2)),_DIV,newnum(2)));
     inc(r);
    end
   else if abs(rep-pi/6)<zero then
    begin
     if m=mCos then
      MoveNode(p,cons(consfunc('rac',newnum(3)),_DIV,newnum(2)))
     else MoveNode(p,cons(consfunc('rac',newnum(3)),_DIV,newnum(3)));
     inc(r);
    end
   else if abs(rep-pi/3)<zero then
    begin
     if m=mCos then
      MoveNode(p,cons(newnum(1),_DIV,newnum(2)))
     else MoveNode(p,consfunc('rac',newnum(3)));
     inc(r);
    end
   else if abs(rep-3*pi/4)<zero then
    begin
     if m=mTan then
      MoveNode(p,newnum(-1))
     else MoveNode(p,cons(cons(newnum(-1),_MUL,consfunc('rac',newnum(2))),
                     _DIV,newnum(2)));
     inc(r);
    end
   else if abs(rep-5*pi/6)<zero then
    begin
     if m=mCos then
      MoveNode(p,cons(cons(newnum(-1),_MUL,consfunc('rac',newnum(3))),
                 _DIV,newnum(2)))
     else MoveNode(p,cons(newnum(-1),_MUL,consfunc('rac',newnum(3))));
     inc(r);
    end
   else if abs(rep-2*pi/3)<zero then
    begin
     if m=mCos then
      MoveNode(p,cons(newnum(-1),_DIV,newnum(2)))
     else MoveNode(p,cons(cons(newnum(-1),_MUL,consfunc('rac',newnum(3))),
                     _DIV,newnum(3)));
     inc(r);
    end

  end;
 AlgSinCos:=r;
End;

Const
 mPGCD=0;
 mPPCM=1;

Function AlgPGCD(p:PNode; m:Integer):Integer;
Var x:TDouble;
    r,i:Integer;
    ok:Boolean;
Begin
 r:=0;
 ok:=(p^.parm[0]^.kind=_NUM);
 if ok then
  begin
   x:=p^.parm[0]^.value;
   i:=1;
   while ok and (i<=p^.nump-1) do
    begin
     ok:=(p^.parm[i]^.kind=_NUM) and (abs(x)<=MaxDouble);
     if ok then
      begin
       if m=mPPCM then
        x:=PPCM(x,p^.parm[i]^.value)
       else x:=PGCD(x,p^.parm[i]^.value);
       inc(i);
      end;
    end;
  end;
 if ok then
  begin
   MoveNode(p,newnum(x));
   inc(r);
  end;
 AlgPGCD:=r;
End;

Const
 mMin=0;
 mMax=1;

Function AlgMinMax(p:PNode; m:Integer):Integer;
Var r,i,sol:Integer;
    rep,t:Real;
    ok:Boolean;
    tmp:PNode;
Begin
 r:=0; sol:=0;
 ok:=EvalNode(p^.parm[0],rep);
 i:=1;
 while (i<=p^.nump-1) and ok do
  begin
   ok:=EvalNode(p^.parm[i],t);
   if ok then
    begin
     if ((m=mMax) and (t>rep)) or ((m=mMin) and (t<rep)) then
      begin
       rep:=t;
       sol:=i;
      end;
     inc(i);
    end;
  end;
 if ok then
  begin
   tmp:=deepcopy(p^.parm[sol]);
   MoveNode(p,tmp);
   inc(r);
  end;
 AlgMinMax:=r;
End;

Function AlgAbs(p:PNode):Integer;
Var r:Integer;
    rep:Real;
    n,i:TDouble;
    tmp:PNode;
Begin
 r:=0;
 if p^.kind=_NUM then
  begin
   n:=p^.parm[0]^.value;
   MoveNode(p,newnum(abs(n)));
   inc(r);
  end
 else if EvalNode(p^.parm[0],rep) then
  begin
   if rep>=0 then
    tmp:=deepcopy(p^.parm[0])
   else tmp:=cons(newnum(-1),_MUL,deepcopy(p^.parm[0]));
   MoveNode(p,tmp);
   inc(r);
  end
 else if IsComplex(p^.parm[0],n,i)<>0 then
  begin
   n:=n*n+i*i;
   MoveNode(p,consfunc('rac',newnum(n)));
   inc(r);
  end;
 AlgAbs:=r;
End;

Function AlgRac(p:PNode):Integer;
Var r:Integer;
    rep:Real;
    a:PNode;
    q,v:TDouble;
Begin
 r:=0;
 a:=p^.parm[0];
 if EvalNode(a,rep) then
  if rep<0 then
   begin
    freetree(p^.parm[0]);
    p^.kind:=_BAD;
    p^.nump:=0;
    AlgRac:=0;
    exit;
   end;
 if a^.kind=_NUM then
  begin
   q:=FacteurCarre(a^.value);
   if q>=1 then
    begin
     v:=a^.value div (q*q);
     if v=1 then
      begin
       MoveNode(p,newnum(q));
       inc(r);
      end
     else if q>1 then
      begin
       MoveNode(p,cons(newnum(q),_MUL,consfunc('rac',newnum(v))));
       inc(r);
      end;
    end;
  end;
 AlgRac:=r;
End;

Function CalcFunc(p:PNode):Integer;
{ valuation algbrique des fonctions }
Var r,i: Integer;
Begin
 r:=0;
 for i:=0 to p^.nump-1 do r:=r+CalcFunc(p^.parm[i]);
 if p^.kind<>_FUN then
  begin
   CalcFunc:=0;
   exit;
  end;
 if (p^.name='rac') and (p^.nump=1) then
  r:=r+AlgRac(p)
 else if (p^.name='abs') and (p^.nump=1) then
  r:=r+AlgAbs(p)
 else if (p^.name='PGCD') and (p^.nump>=1) then
  r:=r+AlgPGCD(p,mPGCD)
 else if (p^.name='PPCM') and (p^.nump>=1) then
  r:=r+AlgPGCD(p,mPPCM)
 else if (p^.name='max') and (p^.nump>=1) then
  r:=r+AlgMinMax(p,mMax)
 else if (p^.name='min') and (p^.nump>=1) then
  r:=r+AlgMinMax(p,mMin)
 else if (p^.name='rad') and (p^.nump=1) then
  r:=r+AlgRad(p)
 else if (p^.name='sin') and (p^.nump=1) then
  r:=r+AlgSinCos(p,mSin)
 else if (p^.name='cos') and (p^.nump=1) then
  r:=r+AlgSinCos(p,mCos)
 else if (p^.name='tan') and (p^.nump=1) then
  r:=r+AlgSinCos(p,mTan);
 CalcFunc:=r;
End;

(* FactoCarre
   Mise en facteur du plus grand facteur carr *)
Function FactoCarre(p:PNode):Integer;
Var a,b:TDouble;
    r:Integer;
Begin
 r:=0;
 if p^.kind=_NUM then
  begin
   a:=FacteurCarre(p^.value);
   if a>1 then
    begin
     b:=p^.value div (a*a);
     MoveNode(p,cons(newnum(a*a),_MUL,newnum(b)));
     inc(r);
    end;
  end;
 FactoCarre:=r;
End;

Procedure Primefact(p:PNode);
{ dcomposition en produit de facteurs premiers }
Var e   : Integer;
    v,f : LongInt;
Begin
 if p^.kind<>_NUM then exit;
 if (p^.kind=_NUM) and (abs(p^.value)<=1) then exit;
 v:=abs(p^.value);
 if p^.value<0 then
  begin
   p^.kind:=_MUL;  p^.nump:=2;
   p^.parm[1]:=newnum(v);  p^.parm[0]:=newnum(-1);
   p:=p^.parm[1];
  end;
 f:=2;
 while f*f<=v do
  begin
   e:=0;
   while v mod f = 0 do
    begin
     v:=v div f;  inc(e);
    end;
 if e=1 then
  begin
   if v<>1 then
    begin
     p^.kind:=_MUL;  p^.nump:=2;
     p^.parm[1]:=newnum(v);  p^.parm[0]:=newnum(f);
     p:=p^.parm[1];
    end;
  end
 else if e>1 then
  begin
   if v<>1 then
    begin
     p^.kind:=_MUL;  p^.nump:=2;
     p^.parm[1]:=newnum(v);  p^.parm[0]:=cons(newnum(f),_EXP,newnum(e));
     p:=p^.parm[1];
    end
   else
    begin
     p^.kind:=_EXP;  p^.nump:=2;
     p^.parm[0]:=newnum(f);  p^.parm[1]:=newnum(e);
    end;
  end;
  f:=f+1;
 end;
End;

Function MoveNums(p:PNode; up,oper:Integer):Integer;
(* Dplacement des nombres et calcul si possible ;
  up indique la direction de dplacement, oper indique l'opration
  traite (addition ou multiplication )  *)
Var i,r:Integer;
    a,b:PNode;
Begin
 r:=0;
 for i:=0 to p^.nump-1 do r:=r+MoveNums(p^.parm[i],up,oper);
 if p^.kind<>oper then
  begin  (* fini *)
   MoveNums:= r;
   exit;
  end;
 a:=p^.parm[0];
 b:=p^.parm[1];
 i:=1;
 if a^.kind<>oper then
  begin (* on traite p directement *)
   a:=p; i:=0;
  end;
 if a^.parm[i]^.kind=_NUM then
  begin
   if p^.parm[1]^.kind=_NUM then
    begin  (* calculer le rsultat de l'opration *)
     if oper=_ADD then
      a^.parm[i]^.value:= a^.parm[i]^.value+p^.parm[1]^.value
     else
      a^.parm[i]^.value:= a^.parm[i]^.value*p^.parm[1]^.value;
     if abs(a^.parm[i]^.value)>MaxDouble then
      begin  (* dpassement de capacit *)
       p^.kind:=_BAD;
       p^.nump:=0;
      end
     else
      begin
       a:=p^.parm[0];
       nodecpy(p,a);
      end;
     freenode(a);
     freenode(b);
     inc(r);
    end
   else if up<>0 then
    begin  (* change de place *)
     p^.parm[1]:=a^.parm[i];
     a^.parm[i]:=b;
     inc(r);
    end;
  end
 else if (b^.kind=_NUM) and (up=0) then
  begin   (* change de place *)
   p^.parm[1]:=a^.parm[i];
   a^.parm[i]:=b;
   inc(r);
  end;
 Movenums:=r;
End;

Function Reduce(a,b:PNode):Integer;
(* simplification des fractions *)
Var r:Integer;
    d,la,lb:LongInt;
Begin
 r:=0;
 if (a^.kind=_NUM) and (b^.kind=_NUM) then
  begin
   if b^.value<0 then
    begin a^.value:=-a^.value; b^.value:=-b^.value end;
   la:=abs(a^.value); lb:=b^.value;
   d:=PGCD(la,lb);
   if d<>1 then
    begin  (* on divise par le PGCD *)
     la:=la div d;
     if a^.value<0 then a^.value:=-la else a^.value:=la;
     lb:=lb div d;
     b^.value:=lb;
     inc(r);
    end;
  end;
 Reduce:=r;
End;

(* Calcnode
   calcule tous les rsultats numriques possibles
*)
Function CalcNode(p:PNode):Integer;
Const
 a1:TDouble=0;
 b1:TDouble=0;
 a2:TDouble=0;
 b2:TDouble=0;
 r1:TDouble=0;
 r2:TDouble=0;
Var i,r:Integer;
    a,b,tmp1,tmp2:PNode;
    t1,t2:Real;
Begin
 r:=0;
 for i:=0 to p^.nump-1 do r:=r+calcnode(p^.parm[i]);
 a:=p^.parm[0];
 b:=p^.parm[1];
 case p^.kind of
  _DEC:
   begin
    val(p^.name,t1,i);
    if i<>0 then
     begin
      p^.kind:=_BAD;
     end
    else
     begin
      ToFrac(t1,a1,b1);
      MoveNode(p,cons(NewNum(a1),_DIV,NewNum(b1)));
     end;
   end;
  _ADD:
   begin
    if (a^.kind=_NUM) and (a^.value=0) then
     begin          (* 0+x := x *)
      nodecpy(p,b);
      freenode(a); freenode(b);
     end
    else if (b^.kind=_NUM) and (b^.value=0) then
     begin     (* x+0 := x *)
      nodecpy(p,a);
      freenode(a); freenode(b);
     end
    else if (a^.kind=_NUM) and (b^.kind=_NUM) then
     begin    (* n+n := n *)
      p^.kind := _NUM;
      p^.nump := 0;
      p^.value := a^.value+b^.value;
      if abs(p^.value)>MaxDouble then
       begin
        p^.kind:=_BAD;
        p^.nump:=0;
       end;
      freenode(a); freenode(b);
     end
    else if (b^.kind=_MUL) and   (* a+-1*b := a-b *)
            (b^.parm[0]^.kind=_NUM) and
            (b^.parm[0]^.value<0) then
     begin
      p^.kind:=_SUB;
      b^.parm[0]^.value := -b^.parm[0]^.value;
     end
    else if (b^.kind=_MUL) and  (* a+b*(-1) := a-b *)
            (b^.parm[1]^.kind=_NUM) and
            (b^.parm[1]^.value<0) then
     begin
      p^.kind := _SUB;
      b^.parm[1]^.value := -b^.parm[1]^.value;
     end
    else dec(r);
    inc(r);
   end;
  _SUB:
   begin
    if (a^.kind=_NUM) and (a^.value=0) then
     begin          (* 0-x := -x *)
      p^.kind := _MUL;
      a^.value := -1;
     end
    else if (a^.kind=_NUM) and (b^.kind=_NUM) then
     begin    (* n-n := n *)
      p^.kind := _NUM;
      p^.nump := 0;
      p^.value := a^.value-b^.value;
      if abs(p^.value)>MaxDouble then
       begin
        p^.kind:=_BAD;
        p^.nump:=0;
       end;
      freenode(a); freenode(b);
     end
    else if (b^.kind=_NUM) and (b^.value=0) then
     begin     (* x-0 := x *)
      nodecpy(p,a);
      freenode(a); freenode(b);
     end
    else dec(r);
    inc(r);
   end;
  _MUL:
   begin
    if (a^.kind=_NUM) and (b^.kind=_NUM) then
     begin         (* n*n := n *)
      p^.kind := _NUM;
      p^.nump := 0;
      p^.value := a^.value*b^.value;
      if abs(p^.value)>MaxDouble then
       begin
        p^.kind:=_BAD;
        p^.nump:=0;
       end;
      freenode(a); freenode(b);
     end
    else if (a^.kind=_NUM) and (a^.value=0) then
     begin     (* 0*x := 0 *)
      p^.kind := _NUM;
      p^.nump := 0;
      p^.value := 0;
      freenode(a); freetree(b);
     end
    else if (b^.kind=_NUM) and (b^.value=0) then
     begin     (* x*0 := 0 *)
      p^.kind := _NUM;
      p^.nump := 0;
      p^.value := 0;
      freetree(a); freenode(b);
     end
    else if (a^.kind=_NUM) and (a^.value=1) then
     begin     (* 1*x := x *)
      nodecpy(p,b);
      freenode(a); freenode(b);
     end
    else if (b^.kind=_NUM) and (b^.value=1) then
     begin     (* x*1 := x *)
      nodecpy(p,a);
      freenode(a); freenode(b);
     end
    else if (iscomplex(a,a1,b1)<>0) and (iscomplex(b,a2,b2)<>0)
           and (b1*b2 - a1*a2<>0) then
     begin  (*  (ai+b)*(ci+d)   *)
      freetree(a); freetree(b);
      p^.parm[1] := newnum(b1*b2 - a1*a2);
      p^.kind := _ADD;
      p^.parm[0]:= cons(newnum(b1*a2+b2*a1),_MUL,newvar('i'));
     end
    else dec(r);
    inc(r);
   end;
  _DIV:
   begin
    if (b^.kind=_NUM) and (b^.value=0) then
     begin          (* x/0 = BAD *)
      p^.kind:=_BAD;
      p^.nump:=0;
      p^.value:=0;
      freetree(a); freenode(b);
      r:=-1;
     end
    else if (a^.kind=_NUM) and (a^.value=0) then
     begin     (* 0/x := 0 *)
      p^.kind := _NUM;
      p^.nump := 0;
      p^.value := 0;
      freenode(a); freetree(b);
     end
    else if (b^.kind=_NUM) and (b^.value=1) then
     begin     (* x/1 := x *)
      nodecpy(p,a);
      freenode(a); freenode(b);
     end
    else if (a^.kind=_NUM) and (b^.kind=_NUM) then
     begin    (* n/n := n *)
      if Reduce(a,b)=0 then dec(r);
     end
    else if (iscomplex(a,a1,b1)<>0) and (iscomplex(b,a2,b2)<>0)
          and (a2<>0) then
     begin  (*  (ai+b)/(ci+d)  *)
      r2 := a2*a2+b2*b2;
      if r2=0 then
       dec(r)   (* division par 0 !!! *)
      else
       begin
        tmp1:=cons(newnum(a1*b2-a2*b1),_DIV,newnum(r2));
        tmp2:=cons(newnum(a1*a2+b1*b2),_DIV,newnum(r2));
        movenode(p,cons(cons(tmp1,_MUL,newvar('i')),_ADD,tmp2));
       end;
     end
    (*
       association des nombres spars dans les noeuds dans les cas
       a/(b*c) ou (a*b)/c
    *)
    else if ((a^.kind=_NUM) or
            ((a^.kind=_MUL) and (a^.parm[1]^.kind=_NUM)))
            and
            ((b^.kind=_NUM) or
            ((b^.kind=_MUL) and (b^.parm[1]^.kind=_NUM))) then
     begin
      if a^.kind=_MUL then a:=a^.parm[1];
      if b^.kind=_MUL then b:=b^.parm[1];
      if Reduce(a,b)=0 then dec(r);  (* pas de changement *)
     end
    else if ((b^.kind=_NUM) or
            ((b^.kind=_MUL) and (b^.parm[1]^.kind=_NUM))) then
     begin
      if b^.kind=_MUL then b:=b^.parm[1];
      if b^.value>=0 then dec(r)
      else
       begin  (* passage du signe - au numrateur *)
        p^.parm[0]:=cons(p^.parm[0],_MUL,newnum(-1));
        b^.value:=-b^.value;
       end;
     end
    else dec(r);
    inc(r);
   end;
  _EXP:
   begin
    if (b^.kind=_NUM) and (b^.value=0) then
     begin          (* x^0 := 1 *)
      p^.kind := _NUM;
      p^.nump := 0;
      p^.value := 1;
      freetree(a); freenode(b);
     end
    else if (a^.kind=_NUM) and (a^.value=1) then
     begin     (* 1^x := 1 *)
      p^.kind := _NUM;
      p^.nump := 0;
      p^.value := 1;
      freenode(a); freetree(b);
     end
    else if (b^.kind=_NUM) and (b^.value=1) then
     begin     (* x^1 := x *)
      nodecpy(p,a);
      freenode(a); freenode(b);
     end
    else if (iscomplex(a,a1,b1)<>0) and (iscomplex(b,a2,b2)<>0) then
     begin        (*  (a1*i+b1)^(a2*i+b2) *)
      if (a2<>0) or (b2<0) then
       dec(r) (* pas de changement *)
       (*  tude des cas simples *)
      else if (a2=0) and (a1=0) and (b1<>0) {and (b1<>10)} then
       begin   (* puissance de rels *)
        t1:=PPuiss(b1,b2);
        if IsPCalcError or (abs(t1)>=MaxDouble) then
         dec(r)  (* calcul impossible *)
        else
         begin
          p^.kind:=_NUM;
          p^.nump:=0;
          p^.value:=round(t1);
          freetree(a); freetree(b);
         end;
       end
      {else if (a2<>0) and (a1<>0) and EstEntier(2*b2) then
               (* (-x)^(n/2):=i^n * x^(n/2) *)
       movenode(p,cons(cons(newvar('i'),_EXP,newnum(2*b2)),
                          _MUL,newnum(PPuiss(-b1,b2))))}
      else if (a2=0) and (b1=0) then
       begin  (*  (ai)^n := a^n * [1,i,-1,-i]  *)
        i:=b2;
        t1:=PPuiss(a1,b2);
        if IsPCalcError or (abs(t1)>=MaxDouble) then
         dec(r)
        else if (i and 1<>0) then
         movenode(p,cons(newvar('i'),_MUL,newnum(round(t1)*(1-(i and 2)))))
        else movenode(p,newnum(round(t1)*(1-(i and 2))));
       end
      else
       begin           (* cas gnral *)
        {r1 := PHypot(a1,b1);
        r2 := PHypot(a2,b2);
        if r2=0 then
         movenode(p,newnum(1))
        else if r1=0 then
         movenode(p,newnum(0))
        else
         begin
          t1 := PArcTan2(a1,b1);
          r2 := PMul(PPuiss(r1,b2),PExp(-t1*a2));
          t2 := PAdd(PMul(t1,b2) , PMul(a2,PLn(r1)));
          movenode(p,cons(cons(newnum(r2*sin(t2)),_MUL,
                    newvar('i')),_ADD,newnum(r2*cos(t2))));
         end;} dec(r);
       end;
      end
    else dec(r);
    inc(r);
   end;
  _FUN:  (* traitement des fonctions *)
   begin
    r:=r+CalcFunc(p);
   end;
 end;
 Calcnode:=r;
End;

END.

{                        Fin du fichier ALGCALC.PAS                         }

=============================================================================
