unit AlgShow;
{ affichage de noeud dans un canvas }
interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, ExtCtrls, Clipbrd,
  AlgConst, AlgUtil, AlgNode, AlgParse, AlgExp;

procedure ResizeNode(canvas:TCanvas; p:PNode;ppr:Integer);
procedure AffNode(canvas:TCanvas; p:PNode; xx,yy:Integer);
procedure LeftPar(canvas:TCanvas; x,y:Integer;p:PNode);
procedure RightPar(canvas:TCanvas; x,y:Integer; p:PNode);

implementation

Var
 xspace,yspace:Integer; { unit de dplacement horizontal et vertical }

Procedure SetAy(p:PNode; h:Integer);
{ transmet les dcalages verticaux aux paramtres }
Var i : Integer;
Begin
 inc(p^.ay,h);
 if p^.nump>0 then
  for i:=0 to p^.nump-1 do SetAy(p^.parm[i],h);
End;

Procedure SetXYSpace(canvas:TCanvas);
{ calcule les units de dplacement }
Begin
 xspace:=canvas.textwidth('X') div 2;
 yspace:=canvas.textheight('X') div 2-2;
End;

Procedure ResizeNode(canvas:TCanvas; p:PNode;ppr:Integer);
{ recalcule la taille du noeud }
Var x: TDouble;
    i,v,t:Integer;
Begin
 if p=nil then exit;
 p^.mpr:=ppr; (* retient le niveau de parenthsage *)
 SetXYSpace(canvas);
 case p^.kind of
  _TXT:
   begin
    p^.ay:=yspace;
    p^.dyh:=yspace;
    p^.dyb:=yspace;
    p^.sx:=canvas.textwidth(p^.Msg^);
   end;
  _NUM, _BAD, _VAR, _DEC:
   begin
    if p^.Kind=_NUM then SetNumName(p);
    if p^.Kind=_BAD then p^.name:=errname;
    p^.ay:=yspace;
    p^.dyh:=yspace;
    p^.dyb:=yspace;
    if (p^.kind=_VAR) and (p^.name='pi')
     then p^.sx:=2*xspace
     else p^.sx:=canvas.textwidth(p^.name);
   end;
  _EQU, _ADD, _SUB,_MUL,_ENV:
   begin
    p^.name:=kname[p^.kind];
    p^.sx:=2*xspace {canvas.textwidth(p^.name)};
    if p^.kind<>_MUL then inc(p^.sx,2*xspace);
    if pr[p^.kind]<p^.mpr then
     inc(p^.sx,4*xspace {canvas.textwidth('()')});
    resizenode(canvas,p^.parm[0],pr[p^.kind]);
    if p^.kind=_SUB then
     resizenode(canvas,p^.parm[1],pr[p^.kind]+1)  (* +1 pour -(a+b) *)
    else resizenode(canvas,p^.parm[1],pr[p^.kind]);
    p^.ay:=max(p^.parm[0]^.ay, p^.parm[1]^.ay);
    p^.dyh:=max(p^.parm[0]^.dyh, p^.parm[1]^.dyh);
    p^.dyb:=max(p^.parm[0]^.dyb, p^.parm[1]^.dyb);
    if p^.parm[0]^.ay<p^.ay then SetAy(p^.parm[0],p^.ay-p^.parm[0]^.ay);
    if p^.parm[1]^.ay<p^.ay then SetAy(p^.parm[1],p^.ay-p^.parm[1]^.ay);
    p^.sx:=p^.sx+p^.parm[0]^.sx + p^.parm[1]^.sx;
   end;
  _DIV:
   begin
    p^.name:=kname[p^.kind];
    resizenode(canvas,p^.parm[0],1);  (* 1 = la division supprime les parenthses *)
    resizenode(canvas,p^.parm[1],1);
    p^.ay:=p^.parm[0]^.dyb+p^.parm[0]^.dyh;
    p^.dyh:=p^.parm[0]^.dyb+p^.parm[0]^.dyh+2;
    p^.dyb:=p^.parm[1]^.dyb+p^.parm[1]^.dyh+2;
    SetAy(p^.parm[1],p^.ay+2);
    p^.sx:=max(p^.parm[0]^.sx,p^.parm[1]^.sx)+2;
    if pr[p^.kind]<p^.mpr then inc(p^.sx,4*xspace {canvas.textwidth('()')});
   end;
  _EXP:
   begin
    p^.name:=kname[p^.kind];
    resizenode(canvas,p^.parm[0],pr[p^.kind]+1);
    resizenode(canvas,p^.parm[1],pr[p^.kind]);
    SetAy(p^.parm[0],p^.parm[1]^.dyh+p^.parm[1]^.dyb);
    p^.ay:=p^.parm[0]^.ay;
    p^.dyb:=p^.parm[0]^.dyb;
    p^.dyh:=p^.parm[0]^.dyh+p^.parm[1]^.dyb+p^.parm[1]^.dyh;
    p^.sx:= p^.parm[0]^.sx + p^.parm[1]^.sx;
    if pr[p^.kind]<p^.mpr then inc(p^.sx,4*xspace {canvas.textwidth('()')});
   end;
  _FUN:
   begin
    if (p^.name='rac') or (p^.name='abs') then
     p^.sx:=0  (* le signe racine a la taille de ')'  *)
    else p^.sx:=canvas.textwidth(p^.name)+2*xspace; (* parenthse fermante  la fin *)
    p^.ay:=yspace; p^.dyh:=yspace; p^.dyb:=yspace;
    t:=0;
    for i:=0 to p^.nump-1 do
     begin
      resizenode(canvas,p^.parm[i],pr[p^.kind]);
      setmax(p^.ay,p^.parm[i]^.ay);
      setmax(p^.dyh,p^.parm[i]^.dyh);
      setmax(p^.dyb,p^.parm[i]^.dyb);
      p^.sx:=p^.sx+ 2*xspace {canvas.textwidth(comma)}+p^.parm[i]^.sx;  (* virgule *)
     end;
    if p^.name='rac' then
     begin  (* dcalage supplmentaire pour signe racine *)
      inc(p^.ay,4);
      inc(p^.dyh,4);
     end;
    for i:=0 to p^.nump-1 do
     if p^.parm[i]^.ay<p^.ay then SetAy(p^.parm[i],p^.ay-p^.parm[i]^.ay);
   end;
  end;
End;

Procedure LeftPar(canvas:TCanvas;x,y:Integer;p:PNode);
{ Parenthse ouvrante }
Begin
 if (p^.dyh=yspace) and (p^.dyb=yspace) then
  begin (* caractre simple *)
   canvas.textout(x,y+p^.ay-yspace,'(');
   exit;
  end;
 (* dessin *)
 with canvas do
 begin
 moveto(x+5,y+p^.ay-p^.dyh);
 lineto(x+2,y+p^.ay-p^.dyh);
 lineto(x+2,y+p^.ay+p^.dyb);
 lineto(x+5,y+p^.ay+p^.dyb);
 end;
End;

Procedure RightPar(canvas:TCanvas;x,y:Integer; p:PNode);
{ Parenthse fermante }
Begin
 if (p^.dyh=yspace) and (p^.dyb=yspace) then
  begin  (* caractre simple *)
   canvas.textout(x,y+p^.ay-yspace,')');
   exit;
  end;
 (* dessin *)
 with canvas do
 begin
 inc(x,2*xspace);
 moveto(x-5,y+p^.ay-p^.dyh);
 lineto(x-2,y+p^.ay-p^.dyh);
 lineto(x-2,y+p^.ay+p^.dyb);
 lineto(x-5,y+p^.ay+p^.dyb);
 end;
End;

Procedure AffNode(canvas:TCanvas;p:PNode; xx,yy:Integer);
{ affichage d'un noeud  la position xx,yy }
Var i:Integer;
    x,y,s : Integer;
Begin
 SetBkMode(Canvas.Handle, Transparent);
 Canvas.Pen.Style:=psSolid;
 Canvas.Pen.Mode:=pmCopy;
 x:=xx;
 y:=yy;
 case p^.kind of
  _TXT:
   begin
    p^.px:=x; p^.py:=y;
    canvas.TextOut(x,y+p^.ay-yspace,p^.Msg^);
   end;
  _NUM,_BAD,_VAR,_DEC:
   begin
    p^.px:=x; p^.py:= y;
    if (p^.kind=_VAR) and (p^.name='pi') then
     begin
      canvas.font.name:='Symbol';
      canvas.textout(x, y+p^.ay-yspace,'p');
      canvas.font.name:='Courier New';
     end
    else canvas.textout(x, y+p^.ay-yspace,p^.name);
   end;
  _EQU,_ADD,_SUB,_MUL,_ENV:
   begin
    p^.px:=x; p^.py:=y;
    if pr[p^.kind]<p^.mpr then
     begin
      leftpar(canvas,x,y,p);
      inc(x,2*xspace);
     end;
    AffNode(canvas,p^.parm[0],x,y);
    inc(x, p^.parm[0]^.sx);
    if p^.kind<>_MUL then inc(x,xspace);
    if p^.kind=_ENV then
     begin
      canvas.font.name:='Symbol';
      canvas.textout(x, y+p^.ay-yspace,#187);
      canvas.font.name:='Courier New';
     end
    else canvas.textout(x,y+p^.ay-yspace,kname[p^.kind]);
    inc(x,2*xspace {canvas.textwidth(kname[p^.kind])});
    if p^.kind<>_MUL then inc(x,xspace);
    AffNode(canvas,p^.parm[1],x,y);
    if pr[p^.kind]<p^.mpr then
     begin
      inc(x,p^.parm[1]^.sx);
      rightpar(canvas,x,y,p);
     end;
   end;
  _DIV:
   begin
    p^.px:= x; p^.py:= y;
    s:=p^.sx;
    if pr[p^.kind]<p^.mpr then
     begin
      leftpar(canvas,x,y,p);
      inc(x,2*xspace);
      dec(s,4*xspace {canvas.textwidth('()')});
     end;
    canvas.moveto(x,y+p^.ay+2);
    canvas.lineto(x+s,y+p^.ay+2);
    AffNode(canvas,p^.parm[0],x+1+(s-p^.parm[0]^.sx) div 2, y);
    AffNode(canvas,p^.parm[1],x+1+(s-p^.parm[1]^.sx) div 2, y);
    if pr[p^.kind]<p^.mpr then
     begin
      x:=x+s;
      rightpar(canvas,x,y,p);
     end;
   end;
  _EXP:
   begin
    p^.px:=x; p^.py:=y;
    if pr[p^.kind]<p^.mpr then
     begin
      leftpar(canvas,x,y,p);
      inc(x,2*xspace);
     end;
    AffNode(canvas,p^.parm[0],x, y);
    inc(x,p^.parm[0]^.sx);
    AffNode(canvas,p^.parm[1],x,y);
    if pr[p^.kind]<p^.mpr then
     begin
      inc(x,p^.parm[1]^.sx);
      rightpar(canvas,x,y,p);
     end;
   end;
  _FUN:
   begin
    p^.px:= x; p^.py:= y;
    if p^.Name='rac' then
     begin  (* racine carre *)
      canvas.moveto(x,y+p^.ay-2*(p^.dyh div 3));
      canvas.lineto(x+3,y+p^.ay+p^.dyb);
      canvas.lineto(x+8,y+p^.ay-p^.dyh);
      canvas.lineto(x+p^.sx-1,y+p^.ay-p^.dyh);
      inc(x,2*xspace);
      AffNode(canvas,p^.parm[0],x,y);
     end
    else if p^.Name='abs' then
     begin  (* valeur absolue *)
      canvas.moveto(x,y+p^.ay-p^.dyh);
      canvas.lineto(x,y+p^.ay+p^.dyb);
      inc(x,4);
      AffNode(canvas,p^.parm[0],x,y);
      inc(x,p^.parm[0]^.sx);
      inc(x,4);
      canvas.moveto(x,y+p^.ay-p^.dyh);
      canvas.lineto(x,y+p^.ay+p^.dyb);
     end
    else
     begin  (* autres fonctions *)
      canvas.textout(x,y+p^.ay-yspace,p^.name);
      inc(x,2*xspace*length(p^.name));
      leftpar(canvas,x,y,p);
      inc(x,2*xspace);
      i:=0;
      repeat
       AffNode(canvas,p^.parm[i],x,y);
       x:=x+p^.parm[i]^.sx;
       inc(i);
       if i<p^.nump
        then begin
              canvas.textout(x,y+p^.ay-yspace,comma);
              inc(x,2*xspace {canvas.textwidth(comma)});
             end;
      until (i>p^.nump-1);
      rightpar(canvas,x,y,p);
     end;
   end;
 end;
 SetBkMode(Canvas.Handle, Opaque);
End;

end.
